function [c,lambz,Rk,rk,h,ip] = ffind_h(h_guess,pi,g,R,e,delta,b,kbar,pe,muzstar,upsil,alpha,phi,i,muup,beta,bbar,gstar,bstar,dtilde,Ntilde,s)

ip=0;
nint=50;
nint2=75;
hlo=h_guess*.00001;
xint=(h_guess-hlo)/nint;
hh1=hlo:xint:h_guess;
hlo=h_guess+xint;
hup=h_guess*700;
xint=(hup-hlo)/nint2;
hh2=hlo:xint:hup;
hh=[hh1 hh2];

[f0,c,lambz,Rk,rk] = find_h(hh(1),pi,g,R,e,delta,b,kbar,pe,muzstar,upsil,alpha,phi, ...
    i,muup,beta,bbar,gstar,bstar,dtilde,Ntilde,s);
ff(1)=f0;
if abs(f0) < .1e-10
    h=hh(1);
    return
end

ix=0;
II=[];
for ii = 2:length(hh)
    h=hh(ii);
    [f1,c,lambz,Rk,rk] = find_h(h,pi,g,R,e,delta,b,kbar,pe,muzstar,upsil,alpha,phi,i,muup,beta,bbar,gstar,bstar,dtilde,Ntilde,s);
    ff(ii)=f1;
    if ff(ii)*ff(ii-1)<0
        ix=ix+1;
        II(ix)=ii;
    end
end

if ix < 1
    c=[];lambz=[];Rk=[];rk=[];h=[];
    ip=1;
end

if ix == 2
    %ignore a crossing if the slope is smooth up to the crossing...otherwise it is most likely a singularity
    %if the first crossing is at the second grid point, look at slope before and after crossing.
    if II(1) == 2
        s1=(ff(II(1))-ff(II(1)-1))/(ff(II(1)+1)-ff(II(1)));
    elseif II(1) > 2
        s1=(ff(II(1))-ff(II(1)-1))/(ff(II(1)-1)-ff(II(1)-2));
    end
    if II(2) == length(ff)
        if s1 < 0
            h_guess=[hh(II(2)-1) hh(II(2))];%in this case, s1 is most likely a singularity and II(2) identifies a unique, well-behaved crossing
        elseif s1 > 0
            error('fatal (ffind_h) seem to have found two candidate solutions for h')
        end
    else
        s2=(ff(II(2))-ff(II(2)-1))/(ff(II(2)-1)-ff(II(2)-2));
        if s1 > 0 && s2 < 0
            ix=1;
        elseif s1 < 0 && s2 > 0
            ix=2;
        elseif s1 < 0 && s2 < 0
            error('fatal (ffind_h) found something that makes no sense')
        elseif s1 > 0 && s2 > 0
            error('fatal (ffind_h) found two candidate solutions for h')
        end
        II=II(ix);
        h_guess=[hh(II-1) hh(II)];
    end
end
if ix > 2
    error('fatal (ffind_h) found more than two solutions')
end
if ix == 1
%     dbstop at 62
%     s1=(ff(II(1))-ff(II(1)-1))/(ff(II(1)+1)-ff(II(1)));
%     if s1 < 0
%         disp('hi')
%     end
    h_guess=[hh(II-1) hh(II)];
end


[x,fval,exitflag]=fzero('find_h',h_guess,optimset,pi,g,R,e,delta,b,kbar,pe,muzstar,upsil,alpha,phi,i,muup,beta,bbar,gstar,bstar,dtilde,Ntilde,s);
if abs(fval)>.1e-10 || abs(imag(x)) > .1e-10 || exitflag ~= 1
    c=[];lambz=[];Rk=[];rk=[];h=[];
    ip=1;
    return
end
h=x;
[ff,c,lambz,Rk,rk] = find_h(h,pi,g,R,e,delta,b,kbar,pe,muzstar,upsil,alpha,phi, ...
        i,muup,beta,bbar,gstar,bstar,dtilde,Ntilde,s);
if abs(ff) > .1e-10
    error('fatal (ffind_h) something incomprehensible happened')
end

    
