function [cc,util,pe,e,s,R,dtilde,kbar,i,c,lambz,Rk,rk,h,Rdb,Rdg,vz,eta,biglambda,wtilde] = ffind_pe(Ntilde,xpe,sigmaL_p,psiL_p,lambdaw_p, ...
    alpha_p,b_p,g,h_guess,abar_p,bbar_p,Ttil_p,gam_p,muzstar_p,pi_p,L,gstar_p,bstar_p,delta_p,upsil_p,phi_p,muup_p,beta_p,lambdaf_p)

R=pi_p*muzstar_p/beta_p;
s=1/lambdaf_p;

gg=[];
nint=100;
xint=(min([1 xpe*1.1])-xpe*.8)/nint;
ppe=xpe*.8:xint:min([1 xpe*1.1]);
gg=[];
ff = find_pe(ppe(1),Ntilde,sigmaL_p,psiL_p,lambdaw_p,alpha_p,b_p,g,h_guess,abar_p,bbar_p,Ttil_p,gam_p,muzstar_p,pi_p,R,L,gstar_p,bstar_p,delta_p,upsil_p,phi_p,muup_p,beta_p,s);
gg(1)=ff;
ix=0;
II=[];
for ii = 2:length(ppe)
    pe=ppe(ii);
    ff = find_pe(pe,Ntilde,sigmaL_p,psiL_p,lambdaw_p,alpha_p,b_p,g,h_guess,abar_p,bbar_p,Ttil_p,gam_p,muzstar_p,pi_p,R,L,gstar_p,bstar_p,delta_p,upsil_p,phi_p,muup_p,beta_p,s);
    gg(ii)=ff;
    if isempty(gg(ii)) ~= 1 && isempty(gg(ii-1)) ~= 1
        if gg(ii)*gg(ii-1) < 0
            ix = ix+1;
            II(ix)=ii;
        end
    end
end
  
if ix == 0
    cc=[];util=[];pe=[];e=[];s=[];R=[];dtilde=[];kbar=[];i=[];c=[];lambz=[];Rk=[];rk=[];h=[];Rdb=[];Rdg=[];vz=[];eta=[];biglambda=[];wtilde=[];
    return
elseif ix == 2
    error('fatal (ffind_pe) two solutions')
elseif ix > 2
    error('fatal (ffind_pe) more than two solutions')
end

ze=[ppe(II-1) ppe(II)];

[x,fval,exitflag]=fzero('find_pe',ze,optimset,Ntilde,sigmaL_p,psiL_p,lambdaw_p,alpha_p,b_p,g,h_guess,abar_p,bbar_p,Ttil_p,gam_p,muzstar_p,pi_p,R,L,gstar_p,bstar_p,delta_p,upsil_p,phi_p,muup_p,beta_p,s);
if abs(fval)>.1e-10 || abs(imag(x)) > .1e-10 || exitflag ~= 1
    error('fatal (ffind_pe) failed to solve steady state')
end
pe=x;

[ff,e,dtilde,kbar,i,c,lambz,Rk,rk,h,Rdb,Rdg,vz,eta,biglambda,wtilde,ipp] = find_pe(pe,Ntilde,sigmaL_p,psiL_p,lambdaw_p,alpha_p,b_p,g,h_guess,abar_p,bbar_p,Ttil_p,gam_p,muzstar_p,pi_p,R,L,gstar_p,bstar_p,delta_p,upsil_p,phi_p,muup_p,beta_p,s);
if abs(ff) > .1e-10
    error('fatal (ffind_pe) something went wrong')
end

util=log(c-(b_p/muzstar_p)*c)-psiL_p*h^(1+sigmaL_p)/(1+sigmaL_p);

cc=-Ntilde+(gam_p/(muzstar_p*pi_p))*((pe*exp(gstar_p)+(1-pe)*exp(bstar_p))*Rk*(Ntilde+dtilde)-R*dtilde)+Ttil_p;