function [ff,c,lambdaz,rk,Rk] = observeL_h(h,e,pi_p,Ntilde,dtilde,kbar,muzstar_p,upsil_p,alpha_p,phi_p,g,i,muup_p,beta_p,b_p,s,delta_p, ...
    bbar_p,gstar_p,bstar_p,lambdaw_p,psiL_p,sigmaL_p,restr)

c=(kbar/(muzstar_p*upsil_p))^alpha_p*h^(1-alpha_p)-phi_p-g-i/muup_p;
lambdaz=(1/c)*(muzstar_p-b_p*beta_p)/(muzstar_p-b_p);
rk=alpha_p*(upsil_p*muzstar_p*h/kbar)^(1-alpha_p)*s;
Rk=(rk+1-delta_p)*pi_p/upsil_p;

if restr == 1
    wtilde=s*(1-alpha_p)*(upsil_p*muzstar_p*h/kbar)^(-alpha_p);
    ff=lambdaw_p*psiL_p*h^sigmaL_p/lambdaz-wtilde;
else
    ff=-e+(lambdaz*bbar_p/(muzstar_p*pi_p))*(exp(gstar_p)-exp(bstar_p))*Rk*(Ntilde+dtilde);
end
