function [h,ip,kbar,dtilde,c,lambdaz,i] = oobserve_h(h_guess,hk,Ntilde,muzstar_p,upsil_p,alpha_p,phi_p,g,muup_p,b_p,beta_p,bbar_p,gstar_p, ...
    bstar_p,kshock,delta_p,pi_p,e,Rk,wtilde,lambdaw_p,psiL_p,sigmaL_p,restr)

ip=0;
nint=75;
hlo=h_guess*.01;
xint=(h_guess-hlo)/nint;
hh1=hlo:xint:h_guess;
hlo=h_guess+xint;
hup=h_guess*1200;
nint=50;
xint=(hup-hlo)/nint;
hh2=hlo:xint:hup;
hh=[hh1 hh2];
%hlo=.4;hup=1.5;
%hlo=0.4817;hup=0.7166;
ff = observe_h(hh(1),hk,Ntilde,muzstar_p,upsil_p,alpha_p,phi_p,g,muup_p,b_p,beta_p,bbar_p,gstar_p,bstar_p,kshock,delta_p,pi_p,e,Rk,wtilde,lambdaw_p,psiL_p,sigmaL_p,restr);
func(1)=ff;
ix=0;
II=[];
for ii = 2:length(hh)
    h=hh(ii);
    ff = observe_h(h,hk,Ntilde,muzstar_p,upsil_p,alpha_p,phi_p,g,muup_p,b_p,beta_p,bbar_p,gstar_p,bstar_p,kshock,delta_p,pi_p,e,Rk,wtilde,lambdaw_p,psiL_p,sigmaL_p,restr);
    func(ii)=ff;
    if func(ii)*func(ii-1) < 0
        ix=ix+1;
        II(ix)=ii;
    end
end

if ix == 0
    error(' fatal (oobserve_h) did not bracket h')
end

if ix == 2    
    if II(1) == 1 || II(1) == length(func)
        error('fatal (oobserve_h) sign switch found on boundary, make grid finer')
    end
    if II(2) == 1 || II(2) == length(func)
        error('fatal (oobserve_h) sign switch found on boundary, make grid finer')
    end
    s1=(func(II(1))-func(II(1)-1))*(func(II(1)+1)-func(II(1)));
    s2=(func(II(2))-func(II(2)-1))*(func(II(2)+1)-func(II(2)));
    if (s1 > 0 && s2 > 0) || (s1<0 && s2<0)
        error(' fatal(oobserve_h) strange behavior in neightborhood of both crossings, make grid finer')
    end    
    if s1 > 0
        NN=[hh(II(1)-1) hh(II(1))];
    else
        NN=[hh(II(2)-1) hh(II(2))];
    end
end

if ix == 1
    s=(func(II)-func(II-1))*(func(II+1)-func(II));
    if s < 0
        disp('warning (oobserve_h) looks like the only sign switch may be a singularity')
    end
    NN=[hh(II-1) hh(II)];
end

if ix > 2    
    ip=1;
    h=[];kbar=[];dtilde=[];c=[];lambdaz=[];i=[];
    return
end

[x,fval,exitflag]=fzero('observe_h',NN,optimset,hk,Ntilde,muzstar_p,upsil_p,alpha_p,phi_p,g,muup_p,b_p,beta_p,bbar_p,gstar_p,bstar_p,kshock,delta_p,pi_p,e,Rk,wtilde,lambdaw_p,psiL_p,sigmaL_p,restr);
if abs(fval) > .1e-10 || exitflag ~= 1
    ip=1;
    h=[];kbar=[];dtilde=[];c=[];lambdaz=[];i=[];
    return
end
h=x;
[ff,kbar,dtilde,c,lambdaz,i] = observe_h(h,hk,Ntilde,muzstar_p,upsil_p,alpha_p,phi_p,g,muup_p,b_p,beta_p,bbar_p,gstar_p,bstar_p,kshock,delta_p,pi_p,e,Rk,wtilde,lambdaw_p,psiL_p,sigmaL_p,restr);
if abs(ff) > .1e-10
        ip=1;
        h=[];kbar=[];dtilde=[];c=[];lambdaz=[];
        return
end
