%checks on financial variables
err(1)=(lambdaz+vz)*bbar_p/(muzstar_p*pi_p)*(Rdg-Rdb)*d+eta;
err(2)=-pe+abar_p+bbar_p*e;%equation f2
err(3)=-1+pe*exp(gstar_p)+(1-pe)*exp(bstar_p);
err(4)=-Re+Rk;
err(5)=vz*pe+eta*lambdaz*bbar_p;
err(6)=-Re+pe*Rdg+(1-pe)*Rdb;
err(7)=(Rdg-Rdb)-spread_cb/(1-pe);%check on equation mu_condition
err(8)=Rdb-exp(bstar_p)*Re*L_cb/(L_cb-1);%check on equation appRdb
err(9)=-spread_cb+((1-pe)/pe)*(1-exp(bstar_p)*L_cb/(L_cb-1))*Re;%check on equation spreadb
err(10)=-sdb_cb+sqrt((1-pe)/pe)*Re;% check on equation sdb
err(11)=-pe+(1-exp(bstar_p))/(exp(gstar_p)-exp(bstar_p));%check on equation p_e
err(12)=(Rdg-Rdb)-(Re/pe)*(1-exp(bstar_p)*L_cb/(L_cb-1));%check on equation mu_condition
err(13)=-e+lambdaz*bbar_p/(muzstar_p*pi_p)*(exp(gstar_p)-exp(bstar_p))/(1-exp(bstar_p))*Re*n;%equation f1

f      = bbar_p*(Rdg-Rdb)*d/(muzstar_p*pi_p);
aa=bbar_p*(Rdg-Rdb)*d*lambdaz*bbar_p/(muzstar_p*pi_p);

err(14)=-vz+lambdaz^2*bbar_p*f/(pe-lambdaz*bbar_p*f);%equation vz
err(15)=eta+(lambdaz+vz)*f;
err(16)=-e+(lambdaz*bbar_p/(muzstar_p*pi_p))*((exp(gstar_p)-exp(bstar_p))*Rk*(n+d)-(Rdg-Rdb)*d);
err(17)=-n+(gam_p/(muzstar_p*pi_p))*Re*n+T_p;

%checks on other variables
err(18)=c+g+i/muup_p-yz;
err(19)=-lambdaz+(1/c)*(muzstar_p-b_p*beta_p)/(muzstar_p-b_p);
err(20)=-rk+alpha_p*epsil_p*(upsil_p*muzstar_p*h/kbar)^(1-alpha_p)*s;
err(21)=-i+kbar*(1-(1-delta_p)/(muzstar_p*upsil_p));
err(22)=-Re+pi_p*muzstar_p/beta_p;
err(23)=yz-epsil_p*(kbar/(muzstar_p*upsil_p))^alpha_p*h^(1-alpha_p)+phi_p;
err(24)=-Rk+(rk+1-delta_p)*pi_p/upsil_p;
err(25)=-wtilde+s*(1-alpha_p)*(kbar/(upsil_p*muzstar_p*h))^alpha_p;
err(26)=-h+(lambdaz*wtilde/(lambdaw_p*psiL_p))^(1/sigmaL_p);
err(27)=yz-(kbar/(h*muzstar_p*upsil_p))^alpha_p*h/lambdaf_p;

if abs(err) > .1e-10
    error('fatal (check_steady) steady state equations not satisfied')
end


