function [ff,e,dtilde,kbar,i,c,lambdaz,Rk,rk,wtilde,h,ip] = observe_pe(pe,Ntilde,alpha_p,b_p,g,h_guess,abar_p,bbar_p,muzstar_p, ...
    pi_p,R,gstar_p,bstar_p,delta_p,upsil_p,phi_p,muup_p,beta_p,s,lambdaw_p,psiL_p,sigmaL_p,restr)

e=(pe-abar_p)/bbar_p;
kshock=pe*exp(gstar_p)+(1-pe)*exp(bstar_p);
Rk=R/kshock;
rk=Rk*upsil_p/pi_p-(1-delta_p);
hk=(rk/(alpha_p*s))^(1/(1-alpha_p))/(upsil_p*muzstar_p);
wtilde=s*(1-alpha_p)*(upsil_p*muzstar_p*hk)^(-alpha_p);
[h,ip,kbar,dtilde,c,lambdaz,i] = oobserve_h(h_guess,hk,Ntilde,muzstar_p,upsil_p,alpha_p,phi_p,g,muup_p,b_p,beta_p,bbar_p,gstar_p, ...
    bstar_p,kshock,delta_p,pi_p,e,Rk,wtilde,lambdaw_p,psiL_p,sigmaL_p,restr);
if ip == 1
    ff=[];e=[];dtilde=[];kbar=[];i=[];c=[];lambdaz=[];Rk=[];rk=[];wtilde=[];h=[];ip=[];
    return
end
ff=wtilde-lambdaw_p*psiL_p*h^sigmaL_p/lambdaz;

    
